// START CUSTOM REVEAL.JS INTEGRATION
(function() {
	if( typeof window.addEventListener === 'function' ) {
		var hljs_nodes = document.querySelectorAll( 'pre code' );

		for( var i = 0, len = hljs_nodes.length; i < len; i++ ) {
			var element = hljs_nodes[i];

			// trim whitespace if data-trim attribute is present
			if( element.hasAttribute( 'data-trim' ) && typeof element.innerHTML.trim === 'function' ) {
				element.innerHTML = element.innerHTML.trim();
			}

			// Now escape html unless prevented by author
			if( ! element.hasAttribute( 'data-noescape' )) {
				element.innerHTML = element.innerHTML.replace(/</g,"&lt;").replace(/>/g,"&gt;");
			}

			// re-highlight when focus is lost (for edited code)
			element.addEventListener( 'focusout', function( event ) {
				hljs.highlightBlock( event.currentTarget );
			}, false );
		}
	}
})();
// END CUSTOM REVEAL.JS INTEGRATION

/*! highlight.js v9.3.0 | BSD3 License | git.io/hljslicense */
!function(e){var t="object"==typeof window&&window||"object"==typeof self&&self;"undefined"!=typeof exports?e(exports):t&&(t.hljs=e({}),"function"==typeof define&&define.amd&&define([],function(){return t.hljs}))}(function(e){function t(e){return e.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;")}function n(e){return e.nodeName.toLowerCase()}function r(e,t){var n=e&&e.exec(t);return n&&0==n.index}function a(e){return/^(no-?highlight|plain|text)$/i.test(e)}function i(e){var t,n,r,i=e.className+" ";if(i+=e.parentNode?e.parentNode.className:"",n=/\blang(?:uage)?-([\w-]+)\b/i.exec(i))return N(n[1])?n[1]:"no-highlight";for(i=i.split(/\s+/),t=0,r=i.length;r>t;t++)if(N(i[t])||a(i[t]))return i[t]}function o(e,t){var n,r={};for(n in e)r[n]=e[n];if(t)for(n in t)r[n]=t[n];return r}function c(e){var t=[];return function r(e,a){for(var i=e.firstChild;i;i=i.nextSibling)3==i.nodeType?a+=i.nodeValue.length:1==i.nodeType&&(t.push({event:"start",offset:a,node:i}),a=r(i,a),n(i).match(/br|hr|img|input/)||t.push({event:"stop",offset:a,node:i}));return a}(e,0),t}function u(e,r,a){function i(){return e.length&&r.length?e[0].offset!=r[0].offset?e[0].offset<r[0].offset?e:r:"start"==r[0].event?e:r:e.length?e:r}function o(e){function r(e){return" "+e.nodeName+'="'+t(e.value)+'"'}l+="<"+n(e)+Array.prototype.map.call(e.attributes,r).join("")+">"}function c(e){l+="</"+n(e)+">"}function u(e){("start"==e.event?o:c)(e.node)}for(var s=0,l="",f=[];e.length||r.length;){var d=i();if(l+=t(a.substr(s,d[0].offset-s)),s=d[0].offset,d==e){f.reverse().forEach(c);do u(d.splice(0,1)[0]),d=i();while(d==e&&d.length&&d[0].offset==s);f.reverse().forEach(o)}else"start"==d[0].event?f.push(d[0].node):f.pop(),u(d.splice(0,1)[0])}return l+t(a.substr(s))}function s(e){function t(e){return e&&e.source||e}function n(n,r){return new RegExp(t(n),"m"+(e.cI?"i":"")+(r?"g":""))}function r(a,i){if(!a.compiled){if(a.compiled=!0,a.k=a.k||a.bK,a.k){var c={},u=function(t,n){e.cI&&(n=n.toLowerCase()),n.split(" ").forEach(function(e){var n=e.split("|");c[n[0]]=[t,n[1]?Number(n[1]):1]})};"string"==typeof a.k?u("keyword",a.k):Object.keys(a.k).forEach(function(e){u(e,a.k[e])}),a.k=c}a.lR=n(a.l||/\w+/,!0),i&&(a.bK&&(a.b="\\b("+a.bK.split(" ").join("|")+")\\b"),a.b||(a.b=/\B|\b/),a.bR=n(a.b),a.e||a.eW||(a.e=/\B|\b/),a.e&&(a.eR=n(a.e)),a.tE=t(a.e)||"",a.eW&&i.tE&&(a.tE+=(a.e?"|":"")+i.tE)),a.i&&(a.iR=n(a.i)),void 0===a.r&&(a.r=1),a.c||(a.c=[]);var s=[];a.c.forEach(function(e){e.v?e.v.forEach(function(t){s.push(o(e,t))}):s.push("self"==e?a:e)}),a.c=s,a.c.forEach(function(e){r(e,a)}),a.starts&&r(a.starts,i);var l=a.c.map(function(e){return e.bK?"\\.?("+e.b+")\\.?":e.b}).concat([a.tE,a.i]).map(t).filter(Boolean);a.t=l.length?n(l.join("|"),!0):{exec:function(){return null}}}}r(e)}function l(e,n,a,i){function o(e,t){for(var n=0;n<t.c.length;n++)if(r(t.c[n].bR,e))return t.c[n]}function c(e,t){if(r(e.eR,t)){for(;e.endsParent&&e.parent;)e=e.parent;return e}return e.eW?c(e.parent,t):void 0}function u(e,t){return!a&&r(t.iR,e)}function d(e,t){var n=m.cI?t[0].toLowerCase():t[0];return e.k.hasOwnProperty(n)&&e.k[n]}function g(e,t,n,r){var a=r?"":w.classPrefix,i='<span class="'+a,o=n?"":"</span>";return i+=e+'">',i+t+o}function b(){if(!R.k)return t(k);var e="",n=0;R.lR.lastIndex=0;for(var r=R.lR.exec(k);r;){e+=t(k.substr(n,r.index-n));var a=d(R,r);a?(M+=a[1],e+=g(a[0],t(r[0]))):e+=t(r[0]),n=R.lR.lastIndex,r=R.lR.exec(k)}return e+t(k.substr(n))}function p(){var e="string"==typeof R.sL;if(e&&!E[R.sL])return t(k);var n=e?l(R.sL,k,!0,L[R.sL]):f(k,R.sL.length?R.sL:void 0);return R.r>0&&(M+=n.r),e&&(L[R.sL]=n.top),g(n.language,n.value,!1,!0)}function h(){y+=void 0!==R.sL?p():b(),k=""}function v(e,t){y+=e.cN?g(e.cN,"",!0):"",R=Object.create(e,{parent:{value:R}})}function _(e,t){if(k+=e,void 0===t)return h(),0;var n=o(t,R);if(n)return n.skip?k+=t:(n.eB&&(k+=t),h(),n.rB||n.eB||(k=t)),v(n,t),n.rB?0:t.length;var r=c(R,t);if(r){var a=R;a.skip?k+=t:(a.rE||a.eE||(k+=t),h(),a.eE&&(k=t));do R.cN&&(y+="</span>"),R.skip||(M+=R.r),R=R.parent;while(R!=r.parent);return r.starts&&v(r.starts,""),a.rE?0:t.length}if(u(t,R))throw new Error('Illegal lexeme "'+t+'" for mode "'+(R.cN||"<unnamed>")+'"');return k+=t,t.length||1}var m=N(e);if(!m)throw new Error('Unknown language: "'+e+'"');s(m);var x,R=i||m,L={},y="";for(x=R;x!=m;x=x.parent)x.cN&&(y=g(x.cN,"",!0)+y);var k="",M=0;try{for(var C,B,I=0;;){if(R.t.lastIndex=I,C=R.t.exec(n),!C)break;B=_(n.substr(I,C.index-I),C[0]),I=C.index+B}for(_(n.substr(I)),x=R;x.parent;x=x.parent)x.cN&&(y+="</span>");return{r:M,value:y,language:e,top:R}}catch(A){if(-1!=A.message.indexOf("Illegal"))return{r:0,value:t(n)};throw A}}function f(e,n){n=n||w.languages||Object.keys(E);var r={r:0,value:t(e)},a=r;return n.filter(N).forEach(function(t){var n=l(t,e,!1);n.language=t,n.r>a.r&&(a=n),n.r>r.r&&(a=r,r=n)}),a.language&&(r.second_best=a),r}function d(e){return w.tabReplace&&(e=e.replace(/^((<[^>]+>|\t)+)/gm,function(e,t){return t.replace(/\t/g,w.tabReplace)})),w.useBR&&(e=e.replace(/\n/g,"<br>")),e}function g(e,t,n){var r=t?x[t]:n,a=[e.trim()];return e.match(/\bhljs\b/)||a.push("hljs"),-1===e.indexOf(r)&&a.push(r),a.join(" ").trim()}function b(e){var t=i(e);if(!a(t)){var n;w.useBR?(n=document.createElementNS("http://www.w3.org/1999/xhtml","div"),n.innerHTML=e.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):n=e;var r=n.textContent,o=t?l(t,r,!0):f(r),s=c(n);if(s.length){var b=document.createElementNS("http://www.w3.org/1999/xhtml","div");b.innerHTML=o.value,o.value=u(s,c(b),r)}o.value=d(o.value),e.innerHTML=o.value,e.className=g(e.className,t,o.language),e.result={language:o.language,re:o.r},o.second_best&&(e.second_best={language:o.second_best.language,re:o.second_best.r})}}function p(e){w=o(w,e)}function h(){if(!h.called){h.called=!0;var e=document.querySelectorAll("pre code");Array.prototype.forEach.call(e,b)}}function v(){addEventListener("DOMContentLoaded",h,!1),addEventListener("load",h,!1)}function _(t,n){var r=E[t]=n(e);r.aliases&&r.aliases.forEach(function(e){x[e]=t})}function m(){return Object.keys(E)}function N(e){return e=(e||"").toLowerCase(),E[e]||E[x[e]]}var w={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},E={},x={};return e.highlight=l,e.highlightAuto=f,e.fixMarkup=d,e.highlightBlock=b,e.configure=p,e.initHighlighting=h,e.initHighlightingOnLoad=v,e.registerLanguage=_,e.listLanguages=m,e.getLanguage=N,e.inherit=o,e.IR="[a-zA-Z]\\w*",e.UIR="[a-zA-Z_]\\w*",e.NR="\\b\\d+(\\.\\d+)?",e.CNR="(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",e.BNR="\\b(0b[01]+)",e.RSR="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",e.BE={b:"\\\\[\\s\\S]",r:0},e.ASM={cN:"string",b:"'",e:"'",i:"\\n",c:[e.BE]},e.QSM={cN:"string",b:'"',e:'"',i:"\\n",c:[e.BE]},e.PWM={b:/\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},e.C=function(t,n,r){var a=e.inherit({cN:"comment",b:t,e:n,c:[]},r||{});return a.c.push(e.PWM),a.c.push({cN:"doctag",b:"(?:TODO|FIXME|NOTE|BUG|XXX):",r:0}),a},e.CLCM=e.C("//","$"),e.CBCM=e.C("/\\*","\\*/"),e.HCM=e.C("#","$"),e.NM={cN:"number",b:e.NR,r:0},e.CNM={cN:"number",b:e.CNR,r:0},e.BNM={cN:"number",b:e.BNR,r:0},e.CSSNM={cN:"number",b:e.NR+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",r:0},e.RM={cN:"regexp",b:/\//,e:/\/[gimuy]*/,i:/\n/,c:[e.BE,{b:/\[/,e:/\]/,r:0,c:[e.BE]}]},e.TM={cN:"title",b:e.IR,r:0},e.UTM={cN:"title",b:e.UIR,r:0},e.METHOD_GUARD={b:"\\.\\s*"+e.UIR,r:0},e.registerLanguage("d",function(e){var t={keyword:"abstract alias align asm assert auto body break byte case cast catch class const continue debug default delete deprecated do else enum export extern final finally for foreach foreach_reverse|10 goto if immutable import in inout int interface invariant is lazy macro mixin module new nothrow out override package pragma private protected public pure ref return scope shared static struct super switch synchronized template this throw try typedef typeid typeof union unittest version void volatile while with __FILE__ __LINE__ __gshared|10 __thread __traits __DATE__ __EOF__ __TIME__ __TIMESTAMP__ __VENDOR__ __VERSION__ __MODULE__ __FUNCTION__ __PRETTY_FUNCTION__",built_in:"bool cdouble cent cfloat char creal dchar delegate double dstring float function idouble ifloat ireal long real short string ubyte ucent uint ulong ushort wchar wstring",literal:"false null true"},n="(0|[1-9][\\d_]*)",r="(0|[1-9][\\d_]*|\\d[\\d_]*|[\\d_]+?\\d)",a="0[bB][01_]+",i="([\\da-fA-F][\\da-fA-F_]*|_[\\da-fA-F][\\da-fA-F_]*)",o="0[xX]"+i,c="([eE][+-]?"+r+")",u="("+r+"(\\.\\d*|"+c+")|\\d+\\."+r+r+"|\\."+n+c+"?)",s="(0[xX]("+i+"\\."+i+"|\\.?"+i+")[pP][+-]?"+r+")",l="("+n+"|"+a+"|"+o+")",f="("+s+"|"+u+")",d="\\\\(['\"\\?\\\\abfnrtv]|u[\\dA-Fa-f]{4}|[0-7]{1,3}|x[\\dA-Fa-f]{2}|U[\\dA-Fa-f]{8})|&[a-zA-Z\\d]{2,};",g={cN:"number",b:"\\b"+l+"(L|u|U|Lu|LU|uL|UL)?",r:0},b={cN:"number",b:"\\b("+f+"([fF]|L|i|[fF]i|Li)?|"+l+"(i|[fF]i|Li))",r:0},p={cN:"string",b:"'("+d+"|.)",e:"'",i:"."},h={b:d,r:0},v={cN:"string",b:'"',c:[h],e:'"[cwd]?'},_={cN:"string",b:'[rq]"',e:'"[cwd]?',r:5},m={cN:"string",b:"`",e:"`[cwd]?"},N={cN:"string",b:'x"[\\da-fA-F\\s\\n\\r]*"[cwd]?',r:10},w={cN:"string",b:'q"\\{',e:'\\}"'},E={cN:"meta",b:"^#!",e:"$",r:5},x={cN:"meta",b:"#(line)",e:"$",r:5},R={cN:"keyword",b:"@[a-zA-Z_][a-zA-Z_\\d]*"},L=e.C("\\/\\+","\\+\\/",{c:["self"],r:10});return{l:e.UIR,k:t,c:[e.CLCM,e.CBCM,L,N,v,_,m,w,b,g,p,E,x,R]}}),e});